#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fstream.h>
//#include <libc.h>

#define TRUE 1
#define FALSE 0

extern int CLlex();
extern char **targv;
extern char **arglim;
extern char *commandline;

extern int compile_type;
extern int doDebug;

void fatal(char *s, char *s2 = "")
{
  cerr << s << " : " << s2 << '\n';
  exit(1);
}

main(int argc, char *argv[]) 
{
  doDebug = 0;
  if (argc < 2) {
    cout << "Usage: coko [-l | -x | -d] <ruleblock.rb | property.pr>" << endl;
    exit(1);
  } 
  if (argc > 2) 
    {
      int c;
      while (--argc > 0 && (*++argv) [0] == '-')
	while (c = *++argv[0])
	  switch (c) {
	  case 'x':
	    compile_type = 0;
	    //cout << "generating excutable" << endl;
	    break;
	  case 'd':
	    //DJA SUMMER 2001
	    //added the -d flag capability which adds debug code to generated code
	    //if the user decided to compile with debug flag
	    doDebug = 1;
	    break;
	  case 'l':
	    compile_type = 1; // Deprecated until working
	    cout << "coko: unsupported function in this release" << endl;
	    exit(1);
	    //cout << "generating shared library" << endl;
	    break;
	    
	  default:
	    cout << "coko: illegal option " << (char) c << endl;
	    argc = 0;
	    exit(1);
	  };
      targv = argv;
      arglim = argv + 1;
      CLlex();
    }
  else
    {
      compile_type = 2;
      targv = argv + 1;
      arglim = argv + argc;
      CLlex();
    }
  
  return 0;
}

