/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc)
//        Xiaoyu Wang (wangxy)
//  FILE: KOTQuestion.C 
//  PROJ: COKO, KOLA
//  DATE: 9/00		                                                    
//
//////////////////////////////////////////////////////////////////////////////

#include "KOTQuestion.H"
extern "C" { int atio(const char *s); }
  
//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TQuestion
// Parameters:()
//
// Constructor.
//
// needs refine later...
//
/////////////////////////////////////////////////////////////////////////////

TQuestion::TQuestion():TagExp(TAGEXP_QUESTION, "?" )
{
    variableNum = 0;
}

//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TQuestion
// Parameters:(TQuestion& other)
//
// Copy Constructor
//
/////////////////////////////////////////////////////////////////////////////

TQuestion::TQuestion(const TQuestion& t):TagExp(TAGEXP_QUESTION, "?")
{
  variableNum = t.getVariableNum();
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: ~TQuestion
// Parameters: ()
//
// Destructor
//
/////////////////////////////////////////////////////////////////////////////

TQuestion::~TQuestion()
{
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: Copy
// Parameters: ()
//
// return the copy of this tagexp
//
/////////////////////////////////////////////////////////////////////////////

TagExp* TQuestion::Copy() const
{
  TQuestion* temp = new TQuestion ();
  temp->setVariableNum(variableNum);
  return temp;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: deepeq
// Parameters: (NonType *)
//
// value-based equality.
//
/////////////////////////////////////////////////////////////////////////////

int TQuestion::deepeq(NonType* other)
{
  return T;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: Myname
// Parameters: ()
//
// return a union type, NameUnion.
// since NonType has 6 different sub-classes....
//
////////////////////////////////////////////////////////////////////////////

NameUnion* TQuestion::Myname()
{
      return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: representation
// Parameters: ()
//
/////////////////////////////////////////////////////////////////////////////

char * TQuestion::representation()
{
  char *res = new char[strlen("?")+1];
  sprintf(res, "?");
  return res;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: Transform
// Parameters: (CState*)
//
// Return corresponding NonType object.
//
// Now it does nothing just return itself 
//
////////////////////////////////////////////////////////////////////////////

NonType* TQuestion::transform(CState* s)
{
  return this;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: compares
// Parameters: (NonType*, CState*)
//
// compare two trees
//
////////////////////////////////////////////////////////////////////////////

int TQuestion::compares(NonType* nt, CState* a)
{
  return T;
}

//////////////////////////////////////////////////////////////////////////
//
// Function Name: compareSTM
// Parameter: (NonType*, CState*)
//
// Check for match between two NonType tree...
//
//////////////////////////////////////////////////////////////////////////

int TQuestion::compareSTM(NonType* nt, CState* a)
{
    return T;
}

//////////////////////////////////////////////////////////////////////////
//
// Function Name: setDEPninvDEP
// Parameter:  (char*, CState*)
//
// set dependency list and....
//
///////////////////////////////////////////////////////////////////////////

void TQuestion::setDEPnInvDEP(char *vn, CState* s)
{
}

///////////////////////////////////////////////////////////////////////////
//
// Function Name: undoSetInvDEP
//
// Parameters: (char *, CState*)
//
// Undo the changes.
//
///////////////////////////////////////////////////////////////////////////

void TQuestion::undoSetInvDEP(char* vn, CState* s)
{
}

///////////////////////////////////////////////////////////////////////////
//
// Function Name: prolog
// Parameters:()
//
// Does nothing, return NULL
//
//////////////////////////////////////////////////////////////////////////

char* TQuestion::prolog()
{
  return NULL;
}

#ifdef _PROLOG_
///////////////////////////////////////////////////////////////////////////
//
// Function Name: sp_prolog
// Parameters:()
//
// Does nothing, return NULL
//
///////////////////////////////////////////////////////////////////////////

SP_term_ref TQuestion::sp_prolog()
{
  return NULL;
}
#endif //_PROLOG_

