/* -*-Mode:c++-*- */


//////////////////////////////////////////////////////////////////////////////
//
// NAME: Mitch Cherniack (mfc@cs.brown.edu)					 	 
// FILE: main.c
// PROJ: The "Karbonator"
// DATE: 5/95
//
//////////////////////////////////////////////////////////////////////////////

#include "KGlobals.H"

#include "OQLParser.H"
#include "KOObject.H"
#include "KOBool.H"
#include "EXOResult.H"
#include "EXBResult.H"
#include "EXOResVAR.H"
#include "ENEnvironment.H"
#include "TYTUnk.H"
#include "TYTSet.H"
#include "TYTInt.H"
#include "TYTTup.H"
#include "SMSchema.H"
#include "SMParser.H"
#include "SMNamesParser.H"
#include "OQLAuxCode.H"

#include <iostream.h>
#include <fstream.h>

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name:  main
// Parameters:	   int, char * []	
// Returns:
//
// Parses all query files provided as input:
//
//   e.g.  parse query1 query2 ... queryn
//
// printing out their resulting KOLA trees in succession.
//         								    
//////////////////////////////////////////////////////////////////////////////

Environment *GLOBALENV;
Schema *SM;

main (int argc, char *argv[])  {

  char *rep;

  SMParser *sp;
  SMNamesParser *snp;
  
      
  char *schema = "/pro/oodb/cokokola/src/kola/Translator/TestSchema";
  char *globals = "/pro/oodb/cokokola/src/kola/Translator/TestGlobals";

  // sp = new SMParser (schema);    
  SM = new Schema (); // sp -> parse ();
  // snp = new SMNamesParser (globals);
  GLOBALENV = new Environment (); // snp -> parse ();

  cout << "======================================================================" << endl;

  ++argv;
  cout << "Processing: " << *argv << endl << endl;

  OQLParser *p = new OQLParser (*argv);
  NonType *k = p -> parse ();
  rep =  k -> representation ();
  cout << rep << endl << endl;
  delete [] rep;
  delete k;
  delete p;
  //  delete sp;
  delete SM;
  // delete snp;
  delete GLOBALENV;
};








